package com.ylx.massage.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ylx.massage.domain.Coupon;
import com.ylx.massage.mapper.CouponReceiveMapper;
import com.ylx.massage.domain.CouponReceive;
import com.ylx.massage.service.CouponReceiveService;
import com.ylx.massage.service.CouponService;
import com.ylx.massage.utils.DateTimeUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * 优惠券领取表(CouponReceive)表服务实现类
 *
 * @author makejava
 * @since 2024-05-14 11:25:45
 */
@Service("couponReceiveService")
public class CouponReceiveServiceImpl extends ServiceImpl<CouponReceiveMapper, CouponReceive> implements CouponReceiveService {

    @Resource
    private CouponService couponService;

    @Override
    public Coupon submit(CouponReceive couponReceive) {
        LambdaQueryWrapper<CouponReceive> queryWrapper = new LambdaQueryWrapper<>();
        Coupon coupon = couponService.getById(couponReceive.getCouponId());
        if (coupon == null) {
            return null;
        }
        queryWrapper.eq(CouponReceive::getOpenid, couponReceive.getOpenid()).eq(CouponReceive::getCouponId, couponReceive.getCouponId());
        //限制没人只能领x张
        List<CouponReceive> one = this.list(queryWrapper);
        if (coupon.getUserLimit() >= one.size()) {
            return null;
        }
        couponReceive.setExpirationTime(DateTimeUtils.addDays(new Date(), coupon.getTermDays()));
        this.save(couponReceive);
        return coupon;
    }
}

